﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace Eka.Inheritance.MDIControls {
    /// <summary>
    /// Class to set the panel border thickness
    /// </summary>
    [Serializable]
    [TypeConverter(typeof(BorderThicknessConverter))]
    [ComVisible(true)]
    public class PanelBorderThickness {
        #region Member Variables
        private byte  mLeftBorderThickness=1;
        private byte mRightBorderThickness=1;
        private byte mTopBorderThickness=1;
        private byte mBottomtBorderThickness=1;
        #endregion

        #region Constructor
        /// <summary>
        /// Constructor
        /// </summary>
        public PanelBorderThickness() {
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="LeftBorderThickness">Left border thickness</param>
        /// <param name="RightBorderThickness">Right border thickness</param>
        /// <param name="TopBorderThickness">Top border thickness</param>
        /// <param name="BottomBorderThickness">Bottom border thickness</param>
        public PanelBorderThickness(byte LeftBorderThickness, byte TopBorderThickness, byte RightBorderThickness, byte BottomBorderThickness) {
            mLeftBorderThickness = LeftBorderThickness;
            mRightBorderThickness = RightBorderThickness;
            mTopBorderThickness = TopBorderThickness;
            mBottomtBorderThickness = BottomBorderThickness;
        }
        #endregion

        #region Propertes
        /// <summary>
        /// Get/Set Panel left border thickness
        /// </summary>
        [DefaultValue(1)]
        public byte LeftBorderThickness {
            get {
                return mLeftBorderThickness ;
            }
            set {
                mLeftBorderThickness = value;
            }
        }

        /// <summary>
        /// Get/Set Panel Top border thickness
        /// </summary>
        [DefaultValue(1)]
        public byte TopBorderThickness {
            get {
                return mTopBorderThickness;
            }
            set {
                mTopBorderThickness = value;
            }
        }

        /// <summary>
        /// Get/Set Panel Right border thickness
        /// </summary>
        [DefaultValue(1)]
        public byte RightBorderThickness {
            get {
                return mRightBorderThickness ;
            }
            set {
                mRightBorderThickness = value;
            }
        }        

        /// <summary>
        /// Get/Set Panel Bottom border thickness
        /// </summary>
        [DefaultValue(1)]
        public byte BottomBorderThickness {
            get {
                return mBottomtBorderThickness ;
            }
            set {
                mBottomtBorderThickness = value;
            }
        }
        #endregion
    }
}
